Smart Proxy - Bug #34193

Slow DNS query getresources after upgrading tfm-runtime package
Description

OS TheForeman: CentOS 7.9.2009
OS DNS Server: RHEL 7.9

Bind Version: 9.11.4.26.P2
Foreman Version: 3.0.1

We experience following issue after updating the additional packages for foreman-smart-proxy from repository version 2.5 and
higher.

This warning message is after provisioning a new server on following steps:

e Create IPv4 DNS record for servernamei.domain.local

2021-12-22T11:47:35 48d893f0 [I] Started POST /dns/

2021-12-22T711:48:01 48d893f0 [W] Slow DNS query getresources for ["servernamel.domain.local",

Resolv::DNS: :Resource: :IN::A] took 26021.57 ms

2021-12-22T11:48:01 48d893f0 [D] Resolver used: #<Resolv::DNS:0x00007faf241e3798 @mutex=#<Thre
ad: :Mutex:0x00007faf241e3770>, Qconfig=#<Resolv::DNS::Config:0x00007faf241e3748 @mutex=#<Threa
d::Mutex:0x00007faf241e3720>, @config_info={:nameserver=>"127.0.0.1"}, @initialized=true, @tim
eouts=[5, 8, 13], @nameserver_port=[["127.0.0.1", 53]], @search=[[]], @ndots=1>, @initialized=

true>

2021-12-22T11:48:01 48d893f0 [D] running /usr/bin/nsupdate -k /etc/foreman-proxy/foreman_dns.k

ey
2021-12-22T711:48:01 48d893f0 [D] nsupdate: executed - server 127.0.0.1

2021-12-22T11:48:01 48d893f0 [D] nsupdate: executed - update add servernamel.domain.local. 60

A 10.40.15.118
2021-12-22T11:48:01 48d893f0 [I] Finished POST /dns/ with 200 (26053.1 ms)

e Create Reverse IPv4 DNS record for servernamei.domain.local

2021-12-22T11:48:01 48d893f0 [I] Started POST /dns/

]
2021-12-22T11:48:27 48d893f0 [W] Slow DNS query getresources for ["118.15.40.10.in-addr.arpa",
]

Resolv::DNS: :Resource: :IN::PTR] took 26027.94 ms

2021-12-22T11:48:27 48d893f0 [D] Resolver used: #<Resolv::DNS:0x00007faf2423dfb8 @mutex=#<Thre
ad: :Mutex:0x00007£faf2423df90>, @config=#<Resolv::DNS::Config:0x00007faf2423df68 @mutex=#<Threa
d::Mutex:0x00007faf2423df40>, @config_info={:nameserver=>"127.0.0.1"}, @initialized=true, @tim
eouts=[5, 8, 13], (@nameserver_port=[["127.0.0.1", 53]], @search=[[]], @ndots=1>, @initialized=

true>

2021-12-22T11:48:27 48d893f0 [D] running /usr/bin/nsupdate -k /etc/foreman-proxy/foreman_dns.k

ey

2021-12-22T11:48:27 48d893f0 [D] nsupdate: executed - server 127.0.0.1

2021-12-22T11:48:27 48d893f0 [D] nsupdate: executed - update add 118.15.40.10.in-addr.arpa.
PTR servernamel.domain.local
2021-12-22T11:48:27 48d893f0 [I] Finished POST /dns/ with 200 (26054.26 ms)

This issue exist, when using the Smart Proxy Modul "DNS for nsupdate" after Upgrading the Smart Proxy above Version 2.5.

We tried various versions to get this issue fixed, but it is not related to the foreman-proxy package, it is caused after upgrading the
package tfm-runtime

Every Foreman SmartProxy Version work (2.5 - 3.0) until you upgrade the tfm-runtime package to version
"tfm-runtime-7.0-4.el7.x86_64".

You can reproduce this behavior with downgrading back to "tfm-runtime-6.1-4.el7.x86_64" (working) or upgrade to
"tfm-runtime-7.0-4.el7.x86_64" (not working or slow dns queries).

Someone else reported this behavior already on community forum:
https://community.theforeman.org/t/foreman-domains-dns-proxy-slow/22558/3

History

#1 - 12/22/2021 10:56 AM - F. Zicklam

- Subject changed from Slow DNS query getresources Resolv::DNS::Resource::IN::A (tfm-runtime) to Slow DNS query getresources after upgrading
tfm-runtime package

#2 - 12/22/2021 10:58 AM - F. Zicklam
All packages are from official repositories.
Working package is in 2.4 repository:

e https://yum.theforeman.org/releases/2.4/el7/x86_64/

Not working in all higher then 2.5 repositories with tfm-runtime version higher 7.0.0

#3 - 12/23/2021 03:13 PM - Lukas Zapletal
Hello,
that error means that Ruby runtime method getresrouces (https:/devdocs.io/ruby~2.7/resolv/dns#method-i-getresources) was slow and perhaps did

not return any result due to timeout. Ruby uses DNS stub implementation which actually performs the DNS lookup by itself not utilizing libc. From logs
it looks like it tries to contact localhost on 53.

Do you have IPv6 on that host? | remember there were some bugs around Ruby DNS resolving but | can't recall what was it. But IPv6 in /etc/hosts or
resolv.conf was breaking Ruby DNS IIRC.

Can you reproduce this behavior if you create a Ruby script trying to resolve the very same name on that host? | am afraid this looks like a Ruby bug,
a reproducer would be necessary and then creating BZ for Red Hat would be better.

#4 - 12/27/2021 12:30 PM - F. Zicklam
Hello Lukas,
thank you for your help.

| tried to change some settings, removed unused hosts at /etc/hosts and disabled IPv6 on my interfaces, now the duration decreased from 26
seconds to 3 seconds for this step/request.

With the old tfm-runtime package it just took 1.6 milliseconds for the same request.
If i will find more tuning options, i will let you know.
Thank you,

regards
Flo

#5 - 01/04/2022 01:31 PM - F. Zicklam

We've updated RH-Ruby2.7 Packages, now we are currently again in milliseconds area.

Please close this issue, thank you for support.

#6 - 01/10/2022 01:59 PM - Ewoud Kohl van Wijngaarden
https://community.theforeman.org/t/foreman-domains-dns-proxy-slow/22558/3
https://yum.theforeman.org/releases/2.4/el7/x86_64/
https://devdocs.io/ruby~2.7/resolv/dns#method-i-getresources

- Status changed from New to Closed

#7 - 01/10/2022 03:24 PM - Lukas Zapletal

Yeah | remember this had a BZ and RH team backported the fix but | could not google it out. Glad this is resolved, cheers!
